/**
 * JIS filter
 * WINDOWSͭʸ̤ʸѴ EUC-JPؤαƶʤ
 * ()  ޿ ʸִޤ JISɥե
 *
 * ӥ
 * gcc -o jisfilter jisfilter.c
 *
 * Ȥ
 * jisfilter < .txt > .txt
 *
 */
#include <stdio.h>

// ASCIIʸ(1byte/ʸ)
#define SET_ASCII        0
// ƥʸ
#define SET_JISX0201_L   1
// 
#define SET_JISX0201_K   2
// ʤ
#define SET_JISX0208     3
// ĥ ISO-2022-JP-1
#define SET_JISX0212     4

//
// ʸѴơ֥뷿
//
struct UConv {
    unsigned int code;
    char *conv;
} tbl_jisx0208[ 99 ];
//
// ü
void init_table ()
{
    // 120 Ѵ
    tbl_jisx0208[ 0 ].code = 0x2d21;
    tbl_jisx0208[ 0 ].conv = "\x23\x31";
    tbl_jisx0208[ 1 ].code = 0x2d22;
    tbl_jisx0208[ 1 ].conv = "\x23\x32";
    tbl_jisx0208[ 2 ].code = 0x2d23;
    tbl_jisx0208[ 2 ].conv = "\x23\x33";
    tbl_jisx0208[ 3 ].code = 0x2d24;
    tbl_jisx0208[ 3 ].conv = "\x23\x34";
    tbl_jisx0208[ 4 ].code = 0x2d25;
    tbl_jisx0208[ 4 ].conv = "\x23\x35";
    tbl_jisx0208[ 5 ].code = 0x2d26;
    tbl_jisx0208[ 5 ].conv = "\x23\x36";
    tbl_jisx0208[ 6 ].code = 0x2d27;
    tbl_jisx0208[ 6 ].conv = "\x23\x37";
    tbl_jisx0208[ 7 ].code = 0x2d28;
    tbl_jisx0208[ 7 ].conv = "\x23\x38";
    tbl_jisx0208[ 8 ].code = 0x2d29;
    tbl_jisx0208[ 8 ].conv = "\x23\x39";
    tbl_jisx0208[ 9 ].code = 0x2d2a;
    tbl_jisx0208[ 9 ].conv = "\x23\x31\x23\x30";
    tbl_jisx0208[ 10 ].code = 0x2d2b;
    tbl_jisx0208[ 10 ].conv = "\x23\x31\x23\x31";
    tbl_jisx0208[ 11 ].code = 0x2d2c;
    tbl_jisx0208[ 11 ].conv = "\x23\x31\x23\x32";
    tbl_jisx0208[ 12 ].code = 0x2d2d;
    tbl_jisx0208[ 12 ].conv = "\x23\x31\x23\x33";
    tbl_jisx0208[ 13 ].code = 0x2d2e;
    tbl_jisx0208[ 13 ].conv = "\x23\x31\x23\x34";
    tbl_jisx0208[ 14 ].code = 0x2d2f;
    tbl_jisx0208[ 14 ].conv = "\x23\x31\x23\x35";
    tbl_jisx0208[ 15 ].code = 0x2d30;
    tbl_jisx0208[ 15 ].conv = "\x23\x31\x23\x36";
    tbl_jisx0208[ 16 ].code = 0x2d31;
    tbl_jisx0208[ 16 ].conv = "\x23\x31\x23\x37";
    tbl_jisx0208[ 17 ].code = 0x2d32;
    tbl_jisx0208[ 17 ].conv = "\x23\x31\x23\x38";
    tbl_jisx0208[ 18 ].code = 0x2d33;
    tbl_jisx0208[ 18 ].conv = "\x23\x31\x23\x39";
    tbl_jisx0208[ 19 ].code = 0x2d34;
    tbl_jisx0208[ 19 ].conv = "\x23\x32\x23\x30";
    // ޿110 Ѵ
    tbl_jisx0208[ 20 ].code = 0x2d35;
    tbl_jisx0208[ 20 ].conv = "\x23\x31";
    tbl_jisx0208[ 21 ].code = 0x2d36;
    tbl_jisx0208[ 21 ].conv = "\x23\x32";
    tbl_jisx0208[ 22 ].code = 0x2d37;
    tbl_jisx0208[ 22 ].conv = "\x23\x33";
    tbl_jisx0208[ 23 ].code = 0x2d38;
    tbl_jisx0208[ 23 ].conv = "\x23\x34";
    tbl_jisx0208[ 24 ].code = 0x2d39;
    tbl_jisx0208[ 24 ].conv = "\x23\x35";
    tbl_jisx0208[ 25 ].code = 0x2d3a;
    tbl_jisx0208[ 25 ].conv = "\x23\x36";
    tbl_jisx0208[ 26 ].code = 0x2d3b;
    tbl_jisx0208[ 26 ].conv = "\x23\x37";
    tbl_jisx0208[ 27 ].code = 0x2d3c;
    tbl_jisx0208[ 27 ].conv = "\x23\x38";
    tbl_jisx0208[ 28 ].code = 0x2d3d;
    tbl_jisx0208[ 28 ].conv = "\x23\x39";
    tbl_jisx0208[ 29 ].code = 0x2d3e;
    tbl_jisx0208[ 29 ].conv = "\x23\x31\x23\x30";
    // ñ ߥڡ
    tbl_jisx0208[ 30 ].code = 0x2d40;
    tbl_jisx0208[ 30 ].conv = "\x25\x5f\x25\x6a";
    tbl_jisx0208[ 31 ].code = 0x2d41;
    tbl_jisx0208[ 31 ].conv = "\x25\x2d\x25\x6d";
    tbl_jisx0208[ 32 ].code = 0x2d42;
    tbl_jisx0208[ 32 ].conv = "\x25\x3b\x25\x73\x25\x41";
    tbl_jisx0208[ 33 ].code = 0x2d43;
    tbl_jisx0208[ 33 ].conv = "\x25\x61\x21\x3c\x25\x48\x25\x6b";
    tbl_jisx0208[ 34 ].code = 0x2d44;
    tbl_jisx0208[ 34 ].conv = "\x25\x30\x25\x69\x25\x60";
    tbl_jisx0208[ 35 ].code = 0x2d45;
    tbl_jisx0208[ 35 ].conv = "\x25\x48\x25\x73";
    tbl_jisx0208[ 36 ].code = 0x2d46;
    tbl_jisx0208[ 36 ].conv = "\x25\x22\x21\x3c\x25\x6b";
    tbl_jisx0208[ 37 ].code = 0x2d47;
    tbl_jisx0208[ 37 ].conv = "\x25\x58\x25\x2f\x25\x3f\x21\x3c\x25\x6b";
    tbl_jisx0208[ 38 ].code = 0x2d48;
    tbl_jisx0208[ 38 ].conv = "\x25\x6a\x25\x43\x25\x48\x25\x6b";
    tbl_jisx0208[ 39 ].code = 0x2d49;
    tbl_jisx0208[ 39 ].conv = "\x25\x6f\x25\x43\x25\x48";
    tbl_jisx0208[ 40 ].code = 0x2d4a;
    tbl_jisx0208[ 40 ].conv = "\x25\x2b\x25\x6d\x25\x6a\x21\x3c";
    tbl_jisx0208[ 41 ].code = 0x2d4b;
    tbl_jisx0208[ 41 ].conv = "\x25\x49\x25\x6b";
    tbl_jisx0208[ 42 ].code = 0x2d4c;
    tbl_jisx0208[ 42 ].conv = "\x25\x3b\x25\x73\x25\x48";
    tbl_jisx0208[ 43 ].code = 0x2d4d;
    tbl_jisx0208[ 43 ].conv = "\x25\x51\x21\x3c\x25\x3b\x25\x73\x25\x48";
    tbl_jisx0208[ 44 ].code = 0x2d4e;
    tbl_jisx0208[ 44 ].conv = "\x25\x5f\x25\x6a\x25\x50\x25\x6b";
    tbl_jisx0208[ 45 ].code = 0x2d4f;
    tbl_jisx0208[ 45 ].conv = "\x25\x5a\x21\x3c\x25\x38";
    // ñ mmm^2
    tbl_jisx0208[ 46 ].code = 0x2d50;
    tbl_jisx0208[ 46 ].conv = "\x23\x6d\x23\x6d";
    tbl_jisx0208[ 47 ].code = 0x2d51;
    tbl_jisx0208[ 47 ].conv = "\x23\x63\x23\x6d";
    tbl_jisx0208[ 48 ].code = 0x2d52;
    tbl_jisx0208[ 48 ].conv = "\x23\x6b\x23\x6d";
    tbl_jisx0208[ 49 ].code = 0x2d53;
    tbl_jisx0208[ 49 ].conv = "\x23\x6d\x23\x67";
    tbl_jisx0208[ 50 ].code = 0x2d54;
    tbl_jisx0208[ 50 ].conv = "\x23\x6b\x23\x67";
    tbl_jisx0208[ 51 ].code = 0x2d55;
    tbl_jisx0208[ 51 ].conv = "\x23\x63\x23\x63";
    tbl_jisx0208[ 52 ].code = 0x2d56;
    tbl_jisx0208[ 52 ].conv = "\x23\x6d\x21\x30\x23\x32";
    //    ʿ
    tbl_jisx0208[ 53 ].code = 0x2d6d;
    tbl_jisx0208[ 53 ].conv = "\x4c\x40\x3c\x23";
    tbl_jisx0208[ 54 ].code = 0x2d6e;
    tbl_jisx0208[ 54 ].conv = "\x42\x67\x40\x35";
    tbl_jisx0208[ 55 ].code = 0x2d6f;
    tbl_jisx0208[ 55 ].conv = "\x3e\x3c\x4f\x42";
    tbl_jisx0208[ 56 ].code = 0x2d5f;
    tbl_jisx0208[ 56 ].conv = "\x4a\x3f\x40\x2e";
    // " No. K.K. TEL
    tbl_jisx0208[ 57 ].code = 0x2d60;
    tbl_jisx0208[ 57 ].conv = "\x21\x49";
    tbl_jisx0208[ 58 ].code = 0x2d61;
    tbl_jisx0208[ 58 ].conv = "\x21\x49";
    tbl_jisx0208[ 59 ].code = 0x2d62;
    tbl_jisx0208[ 59 ].conv = "\x23\x4e\x23\x6f\x21\x25";
    tbl_jisx0208[ 60 ].code = 0x2d63;
    tbl_jisx0208[ 60 ].conv = "\x23\x4b\x21\x25\x23\x4b\x21\x25";
    tbl_jisx0208[ 61 ].code = 0x2d64;
    tbl_jisx0208[ 61 ].conv = "\x23\x54\x23\x45\x23\x4c";
    // 沼
    tbl_jisx0208[ 62 ].code = 0x2d65;
    tbl_jisx0208[ 62 ].conv = "\x21\x4a\x3e\x65\x21\x4b";
    tbl_jisx0208[ 63 ].code = 0x2d66;
    tbl_jisx0208[ 63 ].conv = "\x21\x4a\x43\x66\x21\x4b";
    tbl_jisx0208[ 64 ].code = 0x2d67;
    tbl_jisx0208[ 64 ].conv = "\x21\x4a\x32\x3c\x21\x4b";
    tbl_jisx0208[ 65 ].code = 0x2d68;
    tbl_jisx0208[ 65 ].conv = "\x21\x4a\x3a\x38\x21\x4b";
    tbl_jisx0208[ 66 ].code = 0x2d69;
    tbl_jisx0208[ 66 ].conv = "\x21\x4a\x31\x26\x21\x4b";
    // ()(ͭ)()
    tbl_jisx0208[ 67 ].code = 0x2d6a;
    tbl_jisx0208[ 67 ].conv = "\x21\x4a\x33\x74\x21\x4b";
    tbl_jisx0208[ 68 ].code = 0x2d6b;
    tbl_jisx0208[ 68 ].conv = "\x21\x4a\x4d\x2d\x21\x4b";
    tbl_jisx0208[ 69 ].code = 0x2d6c;
    tbl_jisx0208[ 69 ].conv = "\x21\x4a\x42\x65\x21\x4b";
    // ơ֥νü
    tbl_jisx0208[ 70 ].code = 0;
    tbl_jisx0208[ 70 ].conv = "";
}



int main ()
{
    int jisset = SET_ASCII;
    int ch;
    int f, i, j;

    //
    // Ѵơ֥
    //
    init_table ();
    //
    // ʸ
    //
    while ( ( ch = getc ( stdin ) ) != EOF ) {
        //
        // åڤؤ
        //
        if ( ch == 0x1b ) {
            putc ( 0x1b, stdout );
            switch ( getc ( stdin ) ) {
             case '(':
                putc ( '(', stdout );
                switch ( getc ( stdin ) ) {
                 case 'B':
                    jisset = SET_ASCII;
                    putc ( 'B', stdout );
                    break;
                 case 'J':
                    jisset = SET_JISX0201_L;
                    putc ( 'J', stdout );
                    break;
                 case 'I':
                    jisset = SET_JISX0201_K;
                    putc ( 'I', stdout );
                    break;
                } 
                break;
             case '$':
                putc ( '$', stdout );
                switch ( getc ( stdin ) ) {
                 case 'B':
                    jisset = SET_JISX0208;
                    putc ( 'B', stdout );
                    break;
                 case '(':
                    putc ( '(', stdout );
                    switch ( getc ( stdin ) ) {
                     case 'D':
                        jisset = SET_JISX0212;
                        putc ( 'D', stdout );
                        break;
                    } 
                    break;
                } 
                break;
            }
            //
            continue;
        }
        //
        // ASCIIåȤʤ餽Τޤ޽
        //
        if ( jisset == SET_ASCII ) {
             putc ( ch, stdout );
             continue;
        }
        //
        // ASCIIå ch = 2Х
        //
        i = getc ( stdin );
        if ( i != EOF )  ch = ( ch << 8 ) + i;
        //
        // ʸѴ
        // f = 0:Ѵơ֥оʸǤʤ 1:Ѵоʸä
        //
        f = 0;
        switch ( jisset ) {
         case SET_JISX0208:
            //
            // tbl_jisx0208ơ֥˴ŤѴ
            //
            for ( i = 0; tbl_jisx0208[ i ].code; i++ )
                if ( ch == (tbl_jisx0208[ i ]).code ) {
                    for ( j = 0; (tbl_jisx0208[ i ]).conv[ j ]; j++ )
                        putc ( (tbl_jisx0208[ i ]).conv[ j ], stdout );
                    f = 1;
                }
            if ( f )  continue;
            break;
        }
        //
        // Ѵоݳ
        //
        putc ( ch >> 8, stdout );
        putc ( ch & 0xFF, stdout );
    }
    //
    // ｪλ
    //
    return ( 0 );
}

